<template>
    <v-container class="movie text-center" style="margin-top: 60px">
        <ol style="text-align: justify">
            <li>Of the 20-hundreds releases, neither of which was Jessica's choice, one opened the week and one closed the week.</li>
            <li>The latest of the 19-hundreds releases was shown at 30 minutes past the hour.</li>
            <li>The releases shown before 8:00 pm were on consecutive days, as were the releases shown after 8:00 pm.</li>
            <li>One of the men and one of the women had a showing before 8:00 pm, but neither was mid-week.</li>
            <li>Mark, whose choice was Scarecrow, had a showing at a time of one hour and five minutes after that of Scarface.</li>
            <li>Neither Miss Farmer nor Miss Peters had a showing on an even-numbered day</li>
            <li>88 Minutes showed at a time both 40 minutes to the hour and 40 minutes after the Thursday showing.</li>
        </ol>
		<br />
        <v-simple-table fixed-header>
            <tbody>
            <!---------- Ligne 1/4 ------------>
            <tr>
                <td colspan="5" class="nope">&nbsp;</td>
                <th colspan="5" style="text-align: center">Film</th>
                <th colspan="5" style="text-align: center">Day</th>
                <th colspan="5" style="text-align: center" class="ext-border-right">Time</th>
            </tr>
            <tr>
                <td v-for="(nope, i) in model.cols[0].children" :key="i"
                    class="nope">
                    &nbsp;
                </td>
                <td v-for="(film, i) in model.cols[0].children" :key="film+i"
                    class="vertical ext-border-bottom"
                    :class="{ 'ext-border-right': i === model.cols[0].children.length - 1}">
                    {{ film }}
                </td>
                <td v-for="(day, i) in model.cols[1].children" :key="day+i"
                    class="vertical ext-border-bottom"
                    :class="{ 'ext-border-right': i === model.cols[1].children.length - 1}">
                    {{ day }}
                </td>
                <td v-for="(time, i) in model.cols[2].children" :key="time+i"
                    class="vertical ext-border-bottom"
                    :class="{ 'ext-border-right': i === model.cols[2].children.length - 1}">
                    {{ time }}
                </td>
            </tr>
            <!---------- Ligne 2/4 ------------>
            <th :rowspan="model.rows[0].children.length + 1" class="vertical">{{ model.rows[0].title }}</th>
            <tr v-for="child in model.rows[0].children" :key="child">
                <td colspan="4" class="text-lg-right ext-border-right">{{ child }}</td>
                <td v-for="(field, i) in model.data[model.rows[0].title][child][model.cols[0].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[0].title][child][model.cols[0].title][i] = v"/>
                </td>
                <td v-for="(field, i) in model.data[model.rows[0].title][child][model.cols[1].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[0].title][child][model.cols[1].title][i] = v"/>
                </td>
                <td v-for="(field, i) in model.data[model.rows[0].title][child][model.cols[2].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[0].title][child][model.cols[2].title][i] = v"/>
                </td>
            </tr>
            <!---------- Ligne 3/4 ------------>
            <th :rowspan="model.rows[1].children.length + 1" class="vertical">{{ model.rows[1].title }}</th>
            <tr v-for="child in model.rows[1].children" :key="child">
                <td colspan="4" class="text-lg-right ext-border-right">{{ child }}</td>
                <td v-for="(field, i) in model.data[model.rows[1].title][child][model.cols[0].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[1].title][child][model.cols[0].title][i] = v"/>
                </td>
                <td v-for="(field, i) in model.data[model.rows[1].title][child][model.cols[1].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[1].title][child][model.cols[1].title][i] = v"/>
                </td>
            </tr>
            <!---------- Ligne 4/4 ------------>
            <th :rowspan="model.rows[2].children.length + 1" class="vertical">{{ model.rows[2].title }}</th>
            <tr v-for="child in model.rows[2].children" :key="child">
                <td colspan="4" class="text-lg-right ext-border-right">{{ child }}</td>
                <td v-for="(field, i) in model.data[model.rows[2].title][child][model.cols[0].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[2].title][child][model.cols[0].title][i] = v"/>
                </td>
            </tr>
            </tbody>
        </v-simple-table>
        <v-alert v-show="satisfiable != null"
                 :type="satisfiable ? 'success' : 'error'">
            {{ satisfiable ? "Well done, it's satisfiable" : "Sorry, it's not satisfiable" }}
        </v-alert>
        <v-btn @click="submit" color="success" class="mt-4">Submit</v-btn>
    </v-container>
</template>

<script>
import Selector2 from "@/components/Selector2.component";
import Services from "@/services";

export default {
    name: "Movie",
    components: { Selector2 },
    data: () => ({
        satisfiable: null,
        model: {
            cols: [
                {
                    title: "Film",
                    children: ["88 Minutes", "Donnie Brasco", "Scarecrow", "Scarface", "The Recruit"]
                },
                {
                    title: "Day",
                    children: ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"]
                },
                {
                    title: "Time",
                    children: ["7:35 pm", "7:40 pm", "8:20 pm", "8:30 pm", "8:45 pm"]
                },
            ],
            rows: [
                {
                    title: "Name",
                    children: ["Jessica", "Laurie", "Mark", "Marry", "Sally"]
                },
                {
                    title: "Time",
                    children: ["7:35 pm", "7:40 pm", "8:20 pm", "8:30 pm", "8:45 pm"]
                },
                {
                    title: "Day",
                    children: ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"]
                },
            ],
            data: {}
        }
    }),
    created() {
        for (let row of this.model.rows) {
            this.model.data[row.title] = {};
            for (let rowChildren of row.children) {
                this.model.data[row.title][rowChildren] = {};

                for (let col of this.model.cols) {
                    if (row.title === col.title) break;
                    this.model.data[row.title][rowChildren][col.title] = {};
                    for (let colChildren of col.children) {
                        this.model.data[row.title][rowChildren][col.title][colChildren] = null;
                    }
                }
            }
        }
    },
    methods: {
        async submit() {
            let res = await Services.pb2(this.model.data);
            this.satisfiable = res.satisfiable;
        }
    }
}
</script>

<style scoped>
.nope {
    visibility: hidden;
}

th {
    color: white;
	font-size: 18px !important;
    background-color: black;
	padding: 2px 7px;
    /*border: 3px solid black;*/
    /*text-align: center;*/
}

td {
	border: 1px solid lightgray;
}

td:not(.text-lg-right) {
padding: 0 3px !important;
}

.ext-border-right, tr:not(:nth-child(2)) td:nth-child(5n+1), tr:first-child td:nth-child(5n+1) {
	border-right: 3px solid black !important;
}

tr:nth-child(6n+2) td, .ext-border-bottom {
	border-bottom: 3px solid black !important;
}

tr:nth-child(2) td:nth-child(6){
	border-left: 3px solid black !important;
}

tr:nth-child(4) td:first-child {
	border-top: 3px solid black !important;
}

/*.vertical {*/
/*	writing-mode: tb-rl;*/
/*	-webkit-transform: rotate(180deg);*/
/*	-moz-transform: rotate(180deg);*/
/*	-o-transform: rotate(180deg);*/
/*	-ms-transform: rotate(180deg);*/
/*	transform: rotate(180deg);*/
/*}*/
</style>